package io.github.beradq.adybubbles

enum class ChatPopupMode {
    LOOP, // 持续循环
    ONCE, // 顺序单次
    RANDOM; // 持续随机

    override fun toString(): String {
        return when (this) {
            LOOP -> "loop"
            ONCE -> "once"
            RANDOM -> "random"
        }
    }

    companion object {
        @JvmStatic
        fun fromString(str: String): ChatPopupMode {
            return when (str) {
                "loop" -> LOOP
                "once" -> ONCE
                "random" -> RANDOM
                else -> throw IllegalArgumentException("Invalid chat popup mode: $str")
            }
        }
    }
}